=== debian/changelog ===
charmtimetracker (1.12.0-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:38:58 +1100

charmtimetracker (1.12.0-3build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:04:19 +0000

charmtimetracker (1.12.0-3) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Fix watch file to follow latest github breakages.
  * Change maintainer to Debian KDE Extras Team.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 25 Dec 2022 23:36:43 +0100

charmtimetracker (1.12.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.2.1, no changes needed.

  [ Sandro Knauß ]
  * Bump debhelper from old 12 to 13.
  * Update watch file format version to 4.
  * Update pattern for GitHub archive URLs from /<org>/<repo>/tags
    page/<org>/<repo>/archive/<tag> -> /<org>/<repo>/archive/refs/tags/<tag>.
  * Bump Standards-Version to 4.6.0 (No changes needed).
  * Set Rules-Requires-Root: no.

 -- Sandro Knauß <hefee@debian.org>  Tue, 22 Feb 2022 12:49:33 +0100

charmtimetracker (1.12.0-1) unstable; urgency=medium

  [ Sandro Knauß ]
  * Fix "Please drop "Cross-Platform" from package description" rewrite
    description for the package (Closes: #873917)
  * New upstream release (1.12.0) (Closes: #906455)
  * Update VCS links to salsa.
  * Update copyright file for new upstream.
  * Update patch hunks.
  * Remove upstream applied patches.
  * update ReadMe.txt -> ReadMe.md for docs.
  * Bump compat level to 11 (no changes needed).
  * Bump Standards-Version to 4.2.0 (no changes needed).

 -- Sandro Knauß <hefee@debian.org>  Fri, 24 Aug 2018 13:10:00 +0200

charmtimetracker (1.11.4-1+deb9u1) stretch; urgency=medium

  * Fix "Missing binary dependency on libqt5sql5-sqlite" (Closes: #873918)
    - Adding libqt5sql5-sqlite to depends list of charmtimetracker.
  * Fix "Please drop "Cross-Platform" from package description" rewrite
    description for the package (Closes: #873917)

 -- Sandro Knauß <hefee@debian.org>  Sat, 18 Nov 2017 22:06:24 +0100
