=== debian/control ===
Source: charmtimetracker
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Sandro Knauß <hefee@debian.org>
Build-Depends: cmake (>= 2.8.12~),
               debhelper-compat (= 13),
               libqt5sql5-sqlite,
               libxcb-screensaver0-dev,
               libxcb1-dev,
               qt5keychain-dev,
               qtbase5-dev,
               qtscript5-dev,
               xauth,
               xvfb,
Standards-Version: 4.6.0
Homepage: https://github.com/KDAB/Charm
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/charmtimetracker.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/charmtimetracker
Rules-Requires-Root: no

Package: charmtimetracker
Architecture: any
Depends: libqt5sql5-sqlite, ${misc:Depends}, ${shlibs:Depends}
Description: task based Time Tracker
 It is built around two major ideas - tasks and events.
 Tasks are the things time is spend on, repeatedly. Tasks
 are done in events.
 .
 For example, ironing laundry is a task. The laundry done
 for two hours on last Tuesday is an event in that task.
