=== debian/watch ===
version=4
opts=filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/charmtimetracker-$1.tar.gz/g https://github.com/KDAB/Charm/tags /KDAB/Charm/archive/refs/tags/([\d\.]*)\.tar\.gz
